<?php
/**
 * @brief		Dashboard extension: alexaRanks
 * @author		<a href='http://www.invisionpower.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) 2001 - 2016 Invision Power Services, Inc.
 * @license		http://www.invisionpower.com/legal/standards/
 * @package		IPS Community Suite
 * @subpackage	Spacious Widgets
 * @since		31 Aug 2016
 * @version		SVN_VERSION_NUMBER
 */

namespace IPS\spaciouswidgets\extensions\core\Dashboard;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * @brief	Dashboard extension: alexaRanks
 */
class _alexaRanks
{
	/**
	* Can the current user view this dashboard item?
	*
	* @return	bool
	*/
	public function canView()
	{
		return TRUE;
	}

	/** 
	 * Return the block HTML show on the dashboard
	 *
	 * @return	string
	 */
	public function getBlock()
	{

		/* Grab Setting Vars */

		$lastran = \IPS\Settings ::i()->spacious_alexa_datetime;
		$now = time();
		$globalrank = \IPS\Settings ::i()->spacious_alexa_global_rank;
		$countrycode = \IPS\Settings ::i()->spacious_alexa_countrycode;
		$countryrank = \IPS\Settings ::i()->spacious_alexa_country_rank;
		$globalrankdirection = \IPS\Settings ::i()->spacious_alexa_global_rank_direction;
		$countryrankdirection = \IPS\Settings ::i()->spacious_alexa_country_rank_direction;

		$rawurl = \IPS\Http\Url::baseUrl();

		if (mb_strpos($rawurl,"localhost"))
		{
			$url["host"] = 'all-astronauts.com';
		}
		else
		{
			$url = parse_url( $rawurl );
		}


		/* That's all! Just have to output template now, outside of this if statement of course */


		/* I suppose we should make make global and country rank's look like readable numbers */
		/* The number helper is not working just like other template plugins */
		/* This might be borked due to not passing through locale info or something - hack it in the template */


		/* Display yonder Alexa junk */

		\IPS\Output::i()->cssFiles = array_merge( \IPS\Output::i()->cssFiles, \IPS\Theme::i()->css( 'spaciouswidgets_alx.css', 'spaciouswidgets', 'admin' ) );

		return \IPS\Theme::i()->getTemplate( 'dashboard', 'spaciouswidgets' )->alexaRanks( $globalrank, $countrycode, $countryrank, $globalrankdirection, $countryrankdirection, $lastran, $url);
	}
}