<?php
/**
 * @brief		Dashboard extension: hotTopics
 * @author		<a href='http://www.invisionpower.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) 2001 - 2016 Invision Power Services, Inc.
 * @license		http://www.invisionpower.com/legal/standards/
 * @package		IPS Community Suite
 * @subpackage	Spacious Widgets
 * @since		18 Mar 2017
 * @version		SVN_VERSION_NUMBER
 */

namespace IPS\spaciouswidgets\extensions\core\Dashboard;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * @brief	Dashboard extension: hotTopics
 */
class _hotTopics
{
	/**
	* Can the current user view this dashboard item?
	*
	* @return	bool
	*/
	public function canView()
	{
		return TRUE;
	}

	/** 
	 * Return the block HTML show on the dashboard
	 *
	 * @return	string
	 */
	public function getBlock()
	{
		/* Topics that be rocking over the last three days */
		/* Again, not counting the actual topic creation - just most responses */

		$threedays = \IPS\DateTime::create()->sub( new \DateInterval( 'P3D' ) )->getTimeStamp();

		$hot_topics = \IPS\Db::i()->select( 'topic_id, COUNT(*) AS sohot', 'forums_posts', [ [ 'forums_posts.post_date > ?', $threedays  ], [ 'new_topic = ?', 0 ] ], 'sohot DESC', 5, 'topic_id' );




		\IPS\Output::i()->cssFiles = array_merge( \IPS\Output::i()->cssFiles, \IPS\Theme::i()->css( 'spaciouswidgets_ht.css', 'spaciouswidgets', 'admin' ) );

		return \IPS\Theme::i()->getTemplate( 'dashboard', 'spaciouswidgets' )->hotTopics($hot_topics);
	}
}