<?php
/**
 * @brief		Dashboard extension: similarWebEmbeds
 * @author		<a href='http://www.invisionpower.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) 2001 - 2016 Invision Power Services, Inc.
 * @license		http://www.invisionpower.com/legal/standards/
 * @package		IPS Community Suite
 * @subpackage	Spacious Widgets
 * @since		31 Aug 2016
 * @version		SVN_VERSION_NUMBER
 */

namespace IPS\spaciouswidgets\extensions\core\Dashboard;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * @brief	Dashboard extension: similarWebEmbeds
 */
class _similarWebEmbeds
{
	/**
	* Can the current user view this dashboard item?
	*
	* @return	bool
	*/
	public function canView()
	{
		return TRUE;
	}

	/** 
	 * Return the block HTML show on the dashboard
	 *
	 * @return	string
	 */
	public function getBlock()
	{

		$rawurl = \IPS\Http\Url::baseUrl();

		if (mb_strpos($rawurl,"localhost"))
		{
			$site["host"] = 'all-astronauts.com';
		}
		else
		{
			$site = parse_url( $rawurl );
		}

		/* Display */
		return \IPS\Theme::i()->getTemplate( 'dashboard', 'spaciouswidgets' )->similarWebEmbeds($site);
	}
}