<?php
/**
 * @brief		Dashboard extension: sysLogs
 * @author		<a href='http://www.invisionpower.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) 2001 - 2016 Invision Power Services, Inc.
 * @license		http://www.invisionpower.com/legal/standards/
 * @package		IPS Community Suite
 * @subpackage	Spacious Widgets
 * @since		02 Sep 2016
 * @version		SVN_VERSION_NUMBER
 */

namespace IPS\spaciouswidgets\extensions\core\Dashboard;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * @brief	Dashboard extension: sysLogs
 */
class _sysLogs
{
	/**
	* Can the current user view this dashboard item?
	*
	* @return	bool
	*/
	public function canView()
	{
		return TRUE;
	}

	/** 
	 * Return the block HTML show on the dashboard
	 *
	 * @return	string
	 */
	public function getBlock()
	{

		$syslogs = array();
		$lookback =  "time >= UNIX_TIMESTAMP((NOW() - INTERVAL " . \IPS\Settings::i()->spacious_sl_days ." DAY))";

		foreach ( \IPS\Db::i()->select( '*', 'core_log', $lookback, 'time DESC', 5 ) as $log ) {
			$syslogs[] = $log;
		}

		$last30 = (int) \IPS\Db::i()->select( 'COUNT(*)', 'core_log', 'time >= UNIX_TIMESTAMP((NOW() - INTERVAL 30 DAY))'  )->first();


		\IPS\Output::i()->cssFiles = array_merge( \IPS\Output::i()->cssFiles, \IPS\Theme::i()->css( 'spacious_systemlogs.css', 'spaciouswidgets', 'admin' ) );
		return \IPS\Theme::i()->getTemplate( 'dashboard', 'spaciouswidgets' )->sysLogs( $syslogs, $last30 );
	}
}