//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class spaciouswidgets_hook_newVersions extends _HOOK_CLASS_
{

/* !Hook Data - DO NOT REMOVE */
public static function hookData() {
 return array_merge_recursive( array (
  'dashboard' => 
  array (
    0 => 
    array (
      'selector' => '#acpNewVersion:not(div.ipsAreaBackground_light.ipsPad.ipsPhotoPanel.ipsPhotoPanel_small.ipsPhotoPanel_notPhone)',
      'type' => 'replace',
      'content' => '{{if settings.spacious_lean_newversions}}
		<div id=\'acpNewVersion\' {{if $newVersion[\'security\']}}class=\'cDashboard_securityFix\'{{endif}}>
			<div class=\'ipsPad ipsPhotoPanel ipsPhotoPanel_small ipsPhotoPanel_notPhone\'>
				
				{{if $newVersion[\'security\']}}
					<i class=\'fa fa-warning ipsPos_left ipsResponsive_hidePhone\'></i>
				{{else}}
					<i class=\'fa fa-cog ipsPos_left ipsResponsive_hidePhone\'></i>
				{{endif}}

				<div>
					<h2 class=\'ipsType_reset\'>
						{{if $newVersion[\'security\']}}
							{lang="dashboard_version_info_security" sprintf="$newVersion[\'version\']"}
						{{else}}
							{lang="dashboard_version_info" sprintf="$newVersion[\'version\']"}
						{{endif}}
					</h2>
					{{$timeago = strtotime($newVersion[\'released\']);}}
					<p class=\'ipsType_reset ipsType_normal\'>

						{{if member.hasAcpRestriction( \'core\', \'system\', \'upgrade_manage\' ) || $newVersion[\'updateurl\'] || (isset( $newVersion[\'releasenotes\'] ) and $newVersion[\'releasenotes\'])}}
						<span> {lang="spacious_released"} {datetime="$timeago"}</span>
						{{if member.hasAcpRestriction( \'core\', \'system\', \'upgrade_manage\' )}}
						   <a href="{url="app=core&module=system&controller=upgrade&_new=1"}" class=\'ipsButton ipsButton_veryLight ipsButton_veryVerySmall\'>{lang="upgrade_now"}</a>
						{{endif}}
						{{if $newVersion[\'updateurl\']}}
						<a href=\'{$newVersion[\'updateurl\']}\' target="_blank" class=\'ipsButton ipsButton_alternate ipsButton_small\'>{lang="dashboard_version_moreinfo"}</a>
						{{endif}}
						{{if isset( $newVersion[\'releasenotes\'] ) and $newVersion[\'releasenotes\']}}
						<span> {lang="or"} </span>
						<a href=\'#\' data-ipsDialog data-ipsDialog-content=\'#elDashboardNewVersion\' data-ipsDialog-size=\'narrow\' data-ipsDialog-title="{lang="whats_new_title" sprintf="$newVersion[\'version\']"}">{lang="see_whats_new"} </a>
						{{endif}}

					{{else}}
						{lang="regular_update" sprintf="$newVersion[\'released\']"}
					{{endif}}
					</p>

				</div>
			</div>
		</div>

{{else}}
<div id=\'acpNewVersion\' {{if $newVersion[\'security\']}}class=\'cDashboard_securityFix\'{{endif}}>
			<div class=\'ipsPad ipsPhotoPanel ipsPhotoPanel_small ipsPhotoPanel_notPhone\'>
				
				{{if $newVersion[\'security\']}}
					<i class=\'fa fa-warning ipsPos_left ipsResponsive_hidePhone\'></i>
				{{else}}
					<i class=\'fa fa-info-circle ipsPos_left ipsResponsive_hidePhone\'></i>
				{{endif}}

				<div>
					<h2 class=\'ipsType_reset\'>
						{{if $newVersion[\'security\']}}
							{lang="dashboard_version_info_security" sprintf="$newVersion[\'version\']"}
						{{else}}
							{lang="dashboard_version_info" sprintf="$newVersion[\'version\']"}
						{{endif}}
					</h2>
					
					<p class=\'ipsType_reset ipsType_normal\'>{lang="spacious_released"} {datetime="$timeago"}</p>

					<hr class=\'ipsHr\'>

					{{if member.hasAcpRestriction( \'core\', \'system\', \'upgrade_manage\' ) || $newVersion[\'updateurl\'] || (isset( $newVersion[\'releasenotes\'] ) and $newVersion[\'releasenotes\'])}}
						<ul class=\'ipsList_inline ipsSpacer_top\'>
							{{if member.hasAcpRestriction( \'core\', \'system\', \'upgrade_manage\' )}}
								<li><a href="{url="app=core&module=system&controller=upgrade&_new=1"}" class=\'ipsButton ipsButton_veryLight ipsButton_small\'>{lang="upgrade_now"}</a></li>
							{{endif}}
							{{if $newVersion[\'updateurl\']}}
								<li><a href=\'{$newVersion[\'updateurl\']}\' target="_blank" class=\'ipsButton ipsButton_alternate ipsButton_small\'>{lang="dashboard_version_moreinfo"}</a></li>
							{{endif}}
							{{if isset( $newVersion[\'releasenotes\'] ) and $newVersion[\'releasenotes\']}}
								<li>{lang="or"}</li>
								<li><a href=\'#\' data-ipsDialog data-ipsDialog-content=\'#elDashboardNewVersion\' data-ipsDialog-size=\'narrow\' data-ipsDialog-title="{lang="whats_new_title" sprintf="$newVersion[\'version\']"}">{lang="see_whats_new"} <i class=\'fa fa-angle-right\'></i></a></li>
							{{endif}}
						</ul>
					{{endif}}
				</div>
			</div>
		</div>

{{endif}}',
    ),
    1 => 
    array (
      'selector' => 'div.ipsAreaBackground_light.ipsPad.ipsPhotoPanel.ipsPhotoPanel_small.ipsPhotoPanel_notPhone',
      'type' => 'replace',
      'content' => '{{if settings.spacious_lean_newversions}}
<div class=\'acpBulletin ipsAreaBackground_light ipsPad ipsPhotoPanel ipsPhotoPanel_small ipsPhotoPanel_notPhone\'>
	<i class=\'fa fa-exclamation-circle ipsPos_left ipsResponsive_hidePhone\'></i>
	<div>
		<h2 class=\'ipsType_sectionHead\'><strong>{$bulletin[\'title\']}</strong></h2>
		<div class=\'ipsType_normal ipsType_reset\'>{$bulletin[\'description\']|raw}</div>
		<br>
		<a href=\'{$bulletin[\'link\']}\' target="_blank">{lang="dashboard_version_moreinfo"}</a>
	</div>
</div>
{{else}}
<div class=\'ipsAreaBackground_light ipsPad ipsPhotoPanel ipsPhotoPanel_small ipsPhotoPanel_notPhone\' id=\'acpNewVersion\'>
	<i class=\'fa fa-info-circle ipsPos_left ipsResponsive_hidePhone\'></i>
	<div>
		<h2 class=\'ipsType_sectionHead\'><strong>{$bulletin[\'title\']}</strong></h2>
		<div class=\'ipsType_normal ipsType_reset\'>{$bulletin[\'description\']|raw}</div>
		<br>
		<a href=\'{$bulletin[\'link\']}\' class=\'ipsButton ipsButton_primary ipsButton_small\'>{lang="dashboard_version_moreinfo"} &nbsp;<i class=\'fa fa-chevron-right\'></i></a>
	</div>
</div>
<br>
{{endif}}',
    ),
  ),
), parent::hookData() );
}
/* End Hook Data */


}
