//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class spaciouswidgets_hook_pmMembers extends _HOOK_CLASS_
{


  
  /**
	 * Send PM to Member on ACP Profile
	 *
	 * @return	void
	 */
	public function pm()
	{
		try
		{
	
				$member = \IPS\Member::load( \IPS\Request::i()->id );
		
				if( \IPS\Member::loggedIn()->member_id && !$member->members_disable_pm and !\IPS\Member::loggedIn()->members_disable_pm and \IPS\Member::loggedIn()->canAccessModule( \IPS\Application\Module::get( 'core', 'messaging', 'front' ) ) )
				{
					$form = new \IPS\Helpers\Form( 'form', 'messenger__save' );
					$form->class = 'ipsPad ipsForm ipsForm_vertical';
					$form->add( new \IPS\Helpers\Form\Text( 'messenger_title', NULL, TRUE ) );
					$form->add( new \IPS\Helpers\Form\Editor( 'messenger_content', NULL, TRUE, array( 'app' => 'core', 'key' => 'Admin', 'autoSaveKey' => 'calendar-event', 'attachIds' => NULL ) ) );
		
					if ( $values = $form->values() )
					{
						/* Need to trick \IPS\core\Messenger\Message into thinking we're on the front side, due to checking module permissions */
						$controllerLocation = \IPS\Dispatcher::i()->controllerLocation;
						\IPS\Dispatcher::i()->controllerLocation = 'front';
		
				        $msgTitle = $values['messenger_title'];
				        $msgPost  = $values['messenger_content'];
				        \IPS\Member::loggedIn()->language()->parseOutputForDisplay( $msgTitle );
				        \IPS\Member::loggedIn()->language()->parseOutputForDisplay( $msgPost );
						$pmSender = \IPS\Member::loggedIn();
				   		$conversation = \IPS\core\Messenger\Conversation::createItem( $pmSender, $pmSender->ip_address, \IPS\DateTime::ts( time() ) );
				        $conversation->title = $msgTitle;
				        $conversation->to_member_id = $member->member_id;
				        $conversation->save();
		
						$c_members[] = $member->member_id;
				        $c_members[] = $pmSender->member_id;
						$conversation->authorize( $c_members );
		
						$message = \IPS\core\Messenger\Message::create( $conversation, $msgPost, TRUE, NULL, NULL, $pmSender );
						$conversation->first_msg_id = $message->id;
						$conversation->save();
		
						$message->sendNotifications();
		
						/* Send it back */
						\IPS\Dispatcher::i()->controllerLocation = $controllerLocation;
	
						\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=core&module=members&controller=members&do=view&id='.$member->member_id ), 'message_sent' );
					}
		
					\IPS\Output::i()->output = $form;
				}
				else
				{
					\IPS\Output::i()->error( 'no_permission_send_pm', '2C138/3', 403, '' );
				}
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		




}
