//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class spaciouswidgets_hook_spaciousResetPluginUpdateData extends _HOOK_CLASS_
{


	/**
	 * Admin Log
	 *
	 * @code
	 	\IPS\Session::i()->log( 'acplog__enhancements_enable', array( 'enhancements__foo' => TRUE ) );
	 * @endcode
	 * @param	string	$langKey	Language key for log
	 * @param	array	$params		Key/Values - keys are variables to use in sprintf on $langKey, values are booleans indicating if they are language keys themselves (TRUE) or raw data (FALSE)
	 * @param	bool	$noDupes	If TRUE, will check the last log and not log again if it's the same and less than an hour ago
	 * @return	void
	 */
	public function log( $langKey, $params=array(), $noDupes=false )
	{
		try
		{
	      
	      if ($langKey == 'acplog__application_updated')
	      {
	      $appupdates = json_decode(\IPS\Settings::i()->spacious_current_apppatches, true);
	      
	        if ( isset( \IPS\Request::i()->appKey ) )
						{
							if (array_key_exists(\IPS\Request::i()->appKey, $appupdates))
	                        {
	                            unset($appupdates[\IPS\Request::i()->appKey]);
	                            \IPS\Db::i()->update( 'core_sys_conf_settings', [ 'conf_value' => json_encode($appupdates)  ], [ 'conf_key=?', 'spacious_current_plugupdates' ] );
	      unset( \IPS\Data\Store::i()->settings );
	                        }	
	                    } 
	
	      }
	        
	
	      if ($langKey == 'acplog__plugin_installed')
	      {
	      $plugupdates = json_decode(\IPS\Settings::i()->spacious_current_plugupdates, true);
	      
	        if ( isset( \IPS\Request::i()->id ) )
						{
							if (array_key_exists(\IPS\Request::i()->id, $plugupdates))
	                        {
	                            unset($plugupdates[\IPS\Request::i()->id]);
	                            \IPS\Db::i()->update( 'core_sys_conf_settings', [ 'conf_value' => json_encode($plugupdates)  ], [ 'conf_key=?', 'spacious_current_plugupdates' ] );
	      unset( \IPS\Data\Store::i()->settings );
	                        }	
	                    } 
	
	
	      }
			return call_user_func_array( 'parent::log', array( $langKey, $params, $noDupes ) );
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

}
