<?php


namespace IPS\spaciouswidgets\modules\admin\spaciouswidgets;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * spaciouswidgetsacp
 */
class _spaciouswidgetsacp extends \IPS\Dispatcher\Controller
{


	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		\IPS\Dispatcher::i()->checkAcpPermission( 'spaciouswidgetsacp_manage' );

		$tabs = [];
		$tabs['acp'] = 'sw_acp_settings';
		$tabs['loginpage'] = 'sw_lp_settings';
		$tabs['dashsettings'] = 'sw_dash_settings';
		$tabs['systemoverview'] = 'sw_so_settings';
		$tabs['forumtrends'] = 'sw_ft_settings';
		$tabs['gallerytrends'] = 'sw_gt_settings';
		$tabs['systemlogs'] = 'sw_sl_settings';
		$tabs['membersettings'] = 'sw_member_settings';
		$tabs['similarwebembeds'] = 'sw_swe_settings';
		$tabs['about'] = 'spacious_about';



		$activeTab = \IPS\Request::i()->tab ?: 'acp';
		$activeTabContents = call_user_func( [ $this, 'manage' . ucfirst( $activeTab ) ] );

		if( \IPS\Request::i()->isAjax() and !isset( \IPS\Request::i()->ajaxValidate ) )
		{
			\IPS\Output::i()->output = $activeTabContents;
		}
		else
		{
			\IPS\Output::i()->breadcrumb[] = [ NULL,  'All Astronauts : Spacious ACP 14' ];
			\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('menu__spaciouswidgets_spaciouswidgets_spaciouswidgetsacp');
			\IPS\Output::i()->output 	= \IPS\Theme::i()->getTemplate( 'global', 'core' )->tabs( $tabs, $activeTab, $activeTabContents, \IPS\Http\Url::internal( "app=spaciouswidgets&module=spaciouswidgets&controller=spaciouswidgetsacp" ) );
		}
	}

	/**
	 * Members Widget Settings
	 *
	 * @return	string
	 */
	protected function manageMembersettings()
	{

		$form = new \IPS\Helpers\Form;


		// $form->add( new \IPS\Helpers\Form\YesNo( 'spacious_members_inactive', \IPS\Settings::i()->spacious_members_inactive, FALSE) );
		// $form->add( new \IPS\Helpers\Form\Select( 'spacious_members_inactive', \IPS\Settings::i()->spacious_members_inactive, FALSE, [ 'options' => [ 0 => '1 Week Regulars', 1 => '1 Month Regulars', 2 => '3 Month Regulars', ], 'multiple' => FALSE ] ) );

		$form->addHeader('spacious_aveage_header');
		$form->add( new \IPS\Helpers\Form\Number( 'spacious_bdays_oldyear', \IPS\Settings::i()->spacious_bdays_oldyear, FALSE ));
		$form->add( new \IPS\Helpers\Form\Number( 'spacious_bdays_youngyear', \IPS\Settings::i()->spacious_bdays_youngyear, FALSE ));

		if ( $values = $form->values() )
		{
			$form->saveAsSettings( $values );
			\IPS\Theme::deleteCompiledCss( 'spaciouswidgets', 'admin' );
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=spaciouswidgets&module=spaciouswidgets&controller=spaciouswidgetsacp&tab=membersettings' ), 'saved' );
		}

		return $form;



	}

	/**
	 * General Dashboard Settings - Buttons actually
	 *
	 * @return	string
	 */
	protected function manageDashsettings()
	{

		$form = new \IPS\Helpers\Form;



		$form->addHeader('spacious_dash_buttons');

		$form->add( new \IPS\Helpers\Form\YesNo( 'spacious_dash_task', \IPS\Settings::i()->spacious_dash_task, FALSE) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'spacious_dash_adminlog', \IPS\Settings::i()->spacious_dash_adminlog, FALSE) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'spacious_dash_modlog', \IPS\Settings::i()->spacious_dash_modlog, FALSE) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'spacious_dash_cache', \IPS\Settings::i()->spacious_dash_cache, FALSE) );
		$form->add(
			new \IPS\Helpers\Form\YesNo(
				'spacious_donutcolor', \IPS\Settings::i()->spacious_donutcolor, FALSE,
				[ 'togglesOn' => [ 'spacious_donut_primarycolor_field' ] ]
			)
		);
		$form->add( new \IPS\Helpers\Form\Color( 'spacious_donut_primarycolor', \IPS\Settings::i()->spacious_donut_primarycolor, FALSE, array(), NULL, NULL, NULL, "spacious_donut_primarycolor_field" ) );

		$form->add( new \IPS\Helpers\Form\Number( 'spacious_graph_line_size', \IPS\Settings::i()->spacious_graph_line_size, FALSE, [ 'min' => '0', 'max' => '2', 'decimals' => '0']  ));

		$form->add( new \IPS\Helpers\Form\Select( 'spacious_graph_format', \IPS\Settings::i()->spacious_graph_format, FALSE, [ 'options' => [ 0 => 'Area Chart', 1 => 'Line Chart', ], 'multiple' => FALSE ] ) );


		$form->add( new \IPS\Helpers\Form\Number( 'spacious_graph_trendline_width', \IPS\Settings::i()->spacious_graph_trendline_width, FALSE, [ 'min' => '1', 'max' => '5', 'decimals' => '0']  ));

		$form->add( new \IPS\Helpers\Form\Color( 'spacious_graph_trendline_color', \IPS\Settings::i()->spacious_graph_trendline_color, FALSE, array()) );

		$form->add( new \IPS\Helpers\Form\YesNo( 'spacious_graph_dayblocks', \IPS\Settings::i()->spacious_graph_dayblocks, FALSE) );


		$form->addHeader('spacious_newversions');
		$form->add( new \IPS\Helpers\Form\YesNo( 'spacious_lean_newversions', \IPS\Settings::i()->spacious_lean_newversions, FALSE) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'spacious_dash_patches', \IPS\Settings::i()->spacious_dash_patches, FALSE) );


		if ( $values = $form->values() )
		{

			$form->saveAsSettings( $values );
			\IPS\Theme::deleteCompiledCss( 'spaciouswidgets', 'admin' );
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=spaciouswidgets&module=spaciouswidgets&controller=spaciouswidgetsacp&tab=dashsettings' ), 'saved' );
		}

		return $form;

	}



	/**
	 * System Overview Widget Settings
	 *
	 * @return	string
	 */
	protected function manageSystemoverview()
	{

		$form = new \IPS\Helpers\Form;

		if (\IPS\CIC)
		{
			$form->add(
				new \IPS\Helpers\Form\Number(
					'spacious_syso_cic_quota', \IPS\Settings::i()->spacious_syso_cic_quota, FALSE, [ ], NULL, NULL,
					NULL, 'spacious_syso_cic_quota_field'
				)
			);
		}
		else
		{
			$form->add( new \IPS\Helpers\Form\Number( 'spacious_diskspace_low', \IPS\Settings::i()->spacious_diskspace_low, FALSE, [ 'min' => '5', 'max' => '20', 'decimals' => '0', 'range' => FALSE]  ));
			$form->add( new \IPS\Helpers\Form\Number( 'spacious_diskspace_critical', \IPS\Settings::i()->spacious_diskspace_critical, FALSE, [ 'min' => '1', 'max' => '10', 'decimals' => '0', 'range' => FALSE]  ));
		}


		if ( $values = $form->values() )
		{
			$form->saveAsSettings( $values );

			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=spaciouswidgets&module=spaciouswidgets&controller=spaciouswidgetsacp&tab=systemoverview' ), 'saved' );
		}

		return $form;

	}


	/**
	 * Forum Trends Widget Settings
	 *
	 * @return	string
	 */
	protected function manageForumtrends()
	{

		$form = new \IPS\Helpers\Form;

		$form->add( new \IPS\Helpers\Form\YesNo( 'spacious_ft_graphs', \IPS\Settings::i()->spacious_ft_graphs, FALSE) );


		if ( $values = $form->values() )
		{
			$form->saveAsSettings( $values );

			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=spaciouswidgets&module=spaciouswidgets&controller=spaciouswidgetsacp&tab=forumtrends' ), 'saved' );
		}

		return $form;

	}


	/**
	 * Gallery Trends Widget Settings
	 *
	 * @return	string
	 */
	protected function manageGallerytrends()
	{

		$form = new \IPS\Helpers\Form;

		$form->add(
			new \IPS\Helpers\Form\YesNo(
				'spacious_gt_enablegraph', \IPS\Settings::i()->spacious_gt_enablegraph, FALSE,
				[ 'togglesOn' => [ 'spacious_gt_graphs' ] ]
			)
		);
		$form->add( new \IPS\Helpers\Form\YesNo( 'spacious_gt_graphs', \IPS\Settings::i()->spacious_gt_graphs, FALSE, array(), NULL, NULL, NULL, "spacious_gt_graphs" ) );


		if ( $values = $form->values() )
		{
			$form->saveAsSettings( $values );

			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=spaciouswidgets&module=spaciouswidgets&controller=spaciouswidgetsacp&tab=gallerytrends' ), 'saved' );
		}

		return $form;

	}






	/**
	 * System Overview Widget Settings
	 *
	 * @return	string
	 */
	protected function manageSystemlogs()
	{

		$form = new \IPS\Helpers\Form;

		$form->add( new \IPS\Helpers\Form\Number( 'spacious_sl_days', \IPS\Settings::i()->spacious_sl_days, FALSE, [ 'min' => '3', 'max' => '7', 'decimals' => '0']  ));

		if ( $values = $form->values() )
		{
			$form->saveAsSettings( $values );

			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=spaciouswidgets&module=spaciouswidgets&controller=spaciouswidgetsacp&tab=systemlogs' ), 'saved' );
		}

		return $form;

	}



	/**
	 * SimilarWeb Embeds Widget Settings
	 *
	 * @return	string
	 */
	protected function manageSimilarwebembeds()
	{

		$form = new \IPS\Helpers\Form;
		$form->addHeader( 'sw_swe_websitevisits' );
		$form->add( new \IPS\Helpers\Form\Text( 'spacious_sw_sitetwo', \IPS\Settings::i()->spacious_sw_sitetwo ) );
		$form->add( new \IPS\Helpers\Form\Text( 'spacious_sw_sitethree', \IPS\Settings::i()->spacious_sw_sitethree ) );
		$form->addMessage( 'spacious_sw_message' );
		if ( $values = $form->values() )
		{
			$form->saveAsSettings( $values );

			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=spaciouswidgets&module=spaciouswidgets&controller=spaciouswidgetsacp&tab=similarwebembeds' ), 'saved' );
		}

		return $form;


	}

	/**
	 * Login Page - Have to do it this way as it won't fly as theme settings
	 *
	 * @return	string
	 */
	protected function manageLoginpage()
	{

		$form = new \IPS\Helpers\Form;

		$form->addHeader( 'sw_lp_background' );
		$form->add( new \IPS\Helpers\Form\Color( 'spacious_lp_bgcolor', \IPS\Settings::i()->spacious_lp_bgcolor ) );

		$form->add(
			new \IPS\Helpers\Form\YesNo(
				'spacious_lp_use_bgimage', \IPS\Settings::i()->spacious_lp_use_bgimage, FALSE,
				[ 'togglesOn' => [ 'spacious_login_background_image_field' ] ]
			)
		);

		$form->add( new \IPS\Helpers\Form\Upload( 'spacious_lp_background_image', \IPS\Settings::i()->spacious_lp_background_image ? \IPS\File::get( 'core_Theme', \IPS\Settings::i()->spacious_lp_background_image ) : NULL, FALSE, [ 'image' => true, 'storageExtension' => 'core_Theme' ], NULL, NULL, NULL, "spacious_login_background_image_field" ) );

		$form->addMessage( 'loginbackgrounds' );


		$form->addHeader( 'sw_lp_loginbox' );
		$form->add(
			new \IPS\Helpers\Form\Color( 'spacious_lp_lb_bgcolor', \IPS\Settings::i()->spacious_lp_lb_bgcolor )
		);


		$form->add( new \IPS\Helpers\Form\Number( 'spacious_lp_boxtrans', \IPS\Settings::i()->spacious_lp_boxtrans, FALSE, [ 'min' => '0', 'max' => '1', 'decimals' => '2']  ));




		$form->add(
			new \IPS\Helpers\Form\Number( 'spacious_lp_lb_width', \IPS\Settings::i()->spacious_lp_lb_width )
		);


		$form->add(
			new \IPS\Helpers\Form\Color(
				'spacious_lp_loginbutton_color', \IPS\Settings::i()->spacious_lp_loginbutton_color
			)
		);
		$form->add(
			new \IPS\Helpers\Form\Color(
				'spacious_lp_loginbutton_textcolor', \IPS\Settings::i()->spacious_lp_loginbutton_textcolor
			)
		);


		$form->add(
			new \IPS\Helpers\Form\YesNo(
				'spacious_lp_title_toggle', \IPS\Settings::i()->spacious_lp_title_toggle, FALSE,
				[ 'togglesOn' => [ 'spacious_lp_title_field', 'spacious_lp_lb_text_color_field' ] ]
			)
		);
		$form->add(
			new \IPS\Helpers\Form\Text(
				'spacious_lp_title', \IPS\Settings::i()->spacious_lp_title, FALSE, [ ], NULL, NULL, NULL,
				'spacious_lp_title_field'
			)
		);

		$form->add(
			new \IPS\Helpers\Form\Color( 'spacious_lp_lb_text_color', \IPS\Settings::i()->spacious_lp_lb_text_color, FALSE, [ ], NULL, NULL, NULL,
				'spacious_lp_lb_text_color_field' )
		);

		$form->add( new \IPS\Helpers\Form\YesNo( 'spacious_lp_logoblack', \IPS\Settings::i()->spacious_lp_logoblack ) );


		if ( $values = $form->values() )
		{

			$form->saveAsSettings( $values );
			\IPS\Theme::deleteCompiledCss( 'spaciouswidgets', 'admin' );
			\IPS\Output::i()->redirect(
				\IPS\Http\Url::internal(
					'app=spaciouswidgets&module=spaciouswidgets&controller=spaciouswidgetsacp&tab=loginpage'
				), 'saved'
			);
		}

		return $form;
	}


	/**
	 * Spacious ACP Settings
	 *
	 * @return	string
	 */
	protected function manageAcp()
	{

		$form = new \IPS\Helpers\Form;

		$form->add( new \IPS\Helpers\Form\Upload( 'sacp_favico', \IPS\Settings::i()->sacp_favico ? \IPS\File::get( 'core_Theme', \IPS\Settings::i()->sacp_favico ) : NULL, FALSE, [ 'allowedFileTypes'	=> [ 'ico' ], 'maxFiles' => '1',	 'storageExtension' => 'core_Theme' ], NULL, NULL, NULL, "spacious_favico" ) );

		$form->add( new \IPS\Helpers\Form\YesNo( 'sacp_fixed_header', \IPS\Settings::i()->sacp_fixed_header ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'sacp_front_text', \IPS\Settings::i()->sacp_front_text ) );

		$form->add( new \IPS\Helpers\Form\YesNo( 'sacp_squaredtoggles', \IPS\Settings::i()->sacp_squaredtoggles) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'sacp_flatwidgets', \IPS\Settings::i()->sacp_flatwidgets ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'sacp_hide_widgetcaret', \IPS\Settings::i()->sacp_hide_widgetcaret ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'sacp_tighter_rows', \IPS\Settings::i()->sacp_tighter_rows ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'sacp_phpfunctions_warning', \IPS\Settings::i()->sacp_phpfunctions_warning ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'sacp_db_onlineusers_embiggen', \IPS\Settings::i()->sacp_db_onlineusers_embiggen ) );
		$form->add( new \IPS\Helpers\Form\Color( 'sacp_db_onlineusers_color', \IPS\Settings::i()->sacp_db_onlineusers_color ) );
		$form->add( new \IPS\Helpers\Form\Text( 'sacp_acp_title', \IPS\Settings::i()->sacp_acp_title ) );
		$form->add( new \IPS\Helpers\Form\Color( 'sacp_header_background', \IPS\Settings::i()->sacp_header_background ) );
		$form->add( new \IPS\Helpers\Form\Color( 'sacp_header_textcolor', \IPS\Settings::i()->sacp_header_textcolor ) );
		$form->add( new \IPS\Helpers\Form\Color( 'sacp_search_textcolor', \IPS\Settings::i()->sacp_search_textcolor ) );
		$form->add( new \IPS\Helpers\Form\Color( 'sacp_appmenu_background', \IPS\Settings::i()->sacp_appmenu_background ) );
		$form->add( new \IPS\Helpers\Form\Color( 'sacp_secondarymenu_background', \IPS\Settings::i()->sacp_secondarymenu_background ) );
		$form->add( new \IPS\Helpers\Form\Color( 'sacp_appmenu_fontcolor', \IPS\Settings::i()->sacp_appmenu_fontcolor ) );
		$form->add( new \IPS\Helpers\Form\Color( 'sacp_secondarymenu_fontcolor', \IPS\Settings::i()->sacp_secondarymenu_fontcolor ) );
		$form->add( new \IPS\Helpers\Form\Color( 'sacp_button_color', \IPS\Settings::i()->sacp_button_color ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'sacp_invert_ipslogo', \IPS\Settings::i()->sacp_invert_ipslogo ) );
		$form->add( new \IPS\Helpers\Form\Color( 'sacp_message_info_background', \IPS\Settings::i()->sacp_message_info_background ) );
		$form->add( new \IPS\Helpers\Form\Color( 'sacp_message_warning_background', \IPS\Settings::i()->sacp_message_warning_background ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'spacious_show_themeids', \IPS\Settings::i()->spacious_show_themeids ) );

		$form->addHeader('sacp_anims');

		$form->add( new \IPS\Helpers\Form\Number( 'sacp_anim', \IPS\Settings::i()->sacp_anim, FALSE, [ 'min' => '0', 'max' => '2', 'decimals' => '2']  ));
		$form->add( new \IPS\Helpers\Form\Number( 'sacp_anim_fast', \IPS\Settings::i()->sacp_anim_fast, FALSE, [ 'min' => '0', 'max' => '2', 'decimals' => '2']  ));
		$form->add( new \IPS\Helpers\Form\Number( 'sacp_anim_slow', \IPS\Settings::i()->sacp_anim_slow, FALSE, [ 'min' => '0', 'max' => '2', 'decimals' => '2']  ));
		$form->add( new \IPS\Helpers\Form\Number( 'sacp_anim_very_slow', \IPS\Settings::i()->sacp_anim_very_slow, FALSE, [ 'min' => '0', 'max' => '2', 'decimals' => '2']  ));


		if ( $values = $form->values() )
		{
			$form->saveAsSettings( $values );
			\IPS\Theme::deleteCompiledCss( 'spaciouswidgets', 'admin' );
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=spaciouswidgets&module=spaciouswidgets&controller=spaciouswidgetsacp&tab=acp' ), 'saved' );
		}

		return $form;

	}

	/**
	 * Spacious About
	 *
	 * @return	string
	 */
	protected function manageAbout()
	{

		return \IPS\Theme::i()->getTemplate( 'settings', 'spaciouswidgets', 'admin' )->about();

	}


	/**
	 * Clear Caches
	 *
	 * @return	string
	 */
	protected function spaciousCacheWipe()
	{
		/* Reset theme maps to make sure bad data hasn't been cached - this is */
		/* very probably not necessary but what the hell... */
		foreach( \IPS\Theme::themes() as $id => $set )
		{
			/* Update mappings */
			$set->css_map = [];
			$set->save();
		}

		/* Javascript, CSS, etc.  */
		\IPS\Output::clearJsFiles();
		\IPS\Theme::deleteCompiledCss();
		\IPS\Member::clearCreateMenu();
		\IPS\Db::i()->delete( 'core_cache', [ 'cache_expire<?', time() ] );

		/* Data Store and Cache is where compiled Settings live so just wiping these covers that */
		\IPS\Data\Store::i()->clearAll();
		\IPS\Data\Cache::i()->clearAll();

		/* We can safely call the CIC resync here as the method itself makes the CIC check */
		/* but let's make a check here too just in case... */
		/* Not sure this resync actually makes things better... */
		if (\IPS\CIC)
		{
			\IPS\IPS::resyncIPSCloud( 'If you like Pina Colada and resyncing CIC...' );
		}

		/* Return to Dashboard */
		if (\IPS\CIC)
		{
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=core&module=overview&controller=dashboard' ),
				\IPS\Member::loggedIn()->language()->get('spacious_cic_cleared'));
		}
		else
		{
			\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=core&module=overview&controller=dashboard' ),
				\IPS\Member::loggedIn()->language()->get('spacious_cleared'));
		}
	}

/* CLASS ENDS */
}